unit DemoUnit1;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  Menus,
  Grids,
  StdCtrls,
  ExtCtrls,
  ComCtrls,
  DisplayChange;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    StatusBar1: TStatusBar;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Memo1: TMemo;
    RadioGroup1: TRadioGroup;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    StringGrid1: TStringGrid;
    TMDisplayChange1: TTMDisplayChange;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    procedure TMDisplayChange1AfterControlChange(AControl: TControl;
      AControlRect: TRect);
    procedure TMDisplayChange1BeforeControlChange(AControl: TControl; DT,
      RT: TSysParams; var CanResize: Boolean);
    procedure TMDisplayChange1AfterDisplayChange(Sender: TObject; DT,
      RT: TSysParams; FormRect: TRect; Resized: Boolean);
    procedure TMDisplayChange1BeforeDisplayChange(Sender: TObject; DT,
      RT: TSysParams; FormRect: TRect; var CanResize: Boolean);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.TMDisplayChange1AfterControlChange(AControl: TControl;
  AControlRect: TRect);
var I: Integer;
begin
  if AControl is TStringGrid
    then begin
    StringGrid1.DefaultColWidth := (StringGrid1.Width div 4) - StringGrid1.GridLineWidth;
    StringGrid1.DefaultRowHeight := AControl.Height div 6 - StringGrid1.GridLineWidth;
    for I := 0 to StringGrid1.ColCount - 1 do
      StringGrid1.ColWidths[I] := StringGrid1.ClientWidth div 4 - StringGrid1.GridLineWidth;
    for I := 0 to StringGrid1.RowCount - 1 do
      StringGrid1.RowHeights[I] := StringGrid1.ClientHeight div 5 - StringGrid1.GridLineWidth;
  end;
end;

procedure TForm1.TMDisplayChange1BeforeControlChange(AControl: TControl;
  DT, RT: TSysParams; var CanResize: Boolean);
begin
  if (AControl is TButton)
    then CanResize := CheckBox1.Checked
  else if (AControl is TPanel)
    then CanResize := CheckBox2.Checked
  else if (AControl is TStringGrid)
    then CanResize := CheckBox3.Checked
  else if (AControl is TCheckBox)
    then CanResize := CheckBox4.Checked
  else if (AControl is TRadioGroup)
    then CanResize := CheckBox5.Checked
  else if (AControl is TGroupBox)
    then CanResize := CheckBox6.Checked;

end;

procedure TForm1.TMDisplayChange1AfterDisplayChange(Sender: TObject; DT,
  RT: TSysParams; FormRect: TRect; Resized: Boolean);
begin
  StatusBar1.SimplePanel := true;
  StatusBar1.SimpleText := 'DISPLAY CHANGED ! ('
    + IntToStr(DT.Screen1.Width) + ' x '
    + IntToStr(DT.Screen1.Height)
    + ') => (' + IntToStr(RT.Screen1.Width)
    + ' x ' + IntToStr(RT.Screen1.Height) + ')';
  Edit1.Text := IntToStr(RT.Screen1.Width)
  + ' x ' + IntToStr(RT.Screen1.Height);
end;

procedure TForm1.TMDisplayChange1BeforeDisplayChange(Sender: TObject; DT,
  RT: TSysParams; FormRect: TRect; var CanResize: Boolean);
begin
  CanResize := (RadioGroup1.ItemIndex = 0);
  if not CanResize
    then ShowMessage('The form will NOT be resized!');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Edit1.Text := IntToStr(TMDisplayChange1.RunTime.Screen1.Width)
  + ' x ' + IntToStr(TMDisplayChange1.RunTime.Screen1.Height);

end;

end.

